//
// MPEG1 Audio Layer-3 Library Sample
// Copyright(C) 2000 by TOx2RO / O2 Software All rights reserved.
//
// sample.cpp
//

#include <commdlg.h>
#include "resource.h"
#include "MP3PlayLib.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;						// ݂̃CX^X
TCHAR szTitle[MAX_LOADSTRING];			// ^Cg o[ eLXg
TCHAR szWindowClass[MAX_LOADSTRING];	// ^Cg o[ eLXg

// ̃R[h W[Ɋ܂܂֐̑O錾:
ATOM			MyRegisterClass( HINSTANCE hInstance );
BOOL			InitInstance( HINSTANCE, int );
LRESULT CALLBACK	WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK	About( HWND, UINT, WPARAM, LPARAM );

// MP3PlayNX
MP3Play mp;

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// O[o XgO܂
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SAMPLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass( hInstance );

	// AvP[V̏s܂:
	if( !InitInstance( hInstance, nCmdShow ) ) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SAMPLE);

	// C bZ[W [v:
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		if(!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return msg.wParam;
}

ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style		= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon		= LoadIcon(hInstance, (LPCTSTR)IDI_SAMPLE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_SAMPLE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx( &wcex );
}

BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^X nhۑ܂

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
      CW_USEDEFAULT, 0, 300, 100, NULL, NULL, hInstance, NULL);

   if(!hWnd) 
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
	OPENFILENAME OpenFileName;
	char szFile[MAX_PATH]      = "\0";
	strcpy( szFile, "");

	// CRCU̒`
	EQ eqOld =  {-127,-127,-127,50,50,50,50,-127,-127,-127};
	EQ eqLow =  {127,100,75,50,5,0,0,0,0,0};
	EQ eqHigh = {-127,-127,-127,-127,-127,127,127,127,127,127};

	switch( message ) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch( wmId ) 
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
					mp.Close();
					DestroyWindow( hWnd );
					break;
				case IDM_OLD:
					mp.Equalize(eqOld);
					break;
				case IDM_LOW:
					mp.Equalize(eqLow);
					break;
				case IDM_HIGH:
					mp.Equalize(eqHigh);
					break;
				case IDM_PLAY:
					// Fill in the OPENFILENAME structure to support a template and hook.
					OpenFileName.lStructSize       = sizeof(OPENFILENAME);
					OpenFileName.hwndOwner         = NULL;
					OpenFileName.hInstance         = NULL;
					OpenFileName.lpstrFilter       = "MP3 File(*.MP3)\0*.mp3\0";
					OpenFileName.lpstrCustomFilter = NULL;
					OpenFileName.nMaxCustFilter    = 0;
					OpenFileName.nFilterIndex      = 0;
					OpenFileName.lpstrFile         = szFile;
					OpenFileName.nMaxFile          = sizeof(szFile);
					OpenFileName.lpstrFileTitle    = NULL;
					OpenFileName.nMaxFileTitle     = 0;
					OpenFileName.lpstrInitialDir   = NULL;
					OpenFileName.lpstrTitle        = "Open a File";
					OpenFileName.nFileOffset       = 0;
					OpenFileName.nFileExtension    = 0;
					OpenFileName.lpstrDefExt       = NULL;
					OpenFileName.Flags             = NULL;

					GetOpenFileName(&OpenFileName);

					if (mp.Open(OpenFileName.lpstrFile) == NoError)
					{
						EnableMenuItem(GetMenu(hWnd),IDM_PLAY, MF_DISABLED|MF_GRAYED);
					}
					// [vĐ
					mp.LoopPlay(37,6630,37,0);
					break;
				case IDM_STOP:
					mp.Stop();
					if (mp.Close() == NoError)
					{
						EnableMenuItem(GetMenu(hWnd),IDM_PLAY, MF_ENABLED);
					}
					break;
				default:
				   return DefWindowProc( hWnd, message, wParam, lParam );
			}
			break;
		case WM_DESTROY:

			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}

// o[W{bNXpbZ[W nh
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if( LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL ) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
